package filesystem;

import java.util.ArrayList;
import java.util.List;

class File extends Node { 
  File(String n, Directory p){ 
    super(n,p); 
  }
  public void attach(Observer o){
    if (!_observers.contains(o)){
      _observers.add(o);
    }
  }
  public void detach(Observer o){
    _observers.remove(o);
  }
  public void notifyObservers(){
    for (Observer obs : _observers){
      obs.update();
    }
  }
  public void write(String s){ 
    notifyObservers();
  }
  
  private List<Observer> _observers = new ArrayList<Observer>();
}
